
/*   IBS,RSI,CCI    ,     , 
    (  IBS    ,     ).
       IBS,RSI,CCI .
             ,
          .
   Shift    (Shift    ).
"_1"    1  2.    2 --> "_1 = false".
"positive"   .      --> "positive = true".*/
//+------------------------------------------------------------------+
//|                                               IBS_RSI_CCI_v4.mq4 |
//|                                                       Martingeil |
//+------------------------------------------------------------------+
#property copyright "Martingeil"
#property link      "fx.09@mail.ru"
 
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 LimeGreen
#property indicator_color3 Maroon
#property indicator_color4 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_maximum 1
#property indicator_minimum 0

//----    -------------------------------
extern int      per_IBS  =   5; // IBS
extern int      per_RSI  =  14; // RSI 
extern int      per_CCI  =  14; // CCI
extern int      porog    =  50; //
//----    VKWB ---------------------------           
extern int      RangePeriod_VKWB  = 25;
extern int      SmoothPeriod_VKWB =  3;
//------------------------------------------------------------
double koef_ibs = 7.0;
double koef_rsi = 9.0;
double koef_cci = 1.0;
int  = 0;//     
int app_price_RSI = 0;//app_price
int app_price_CCI = 0;//app_price
bool ibs = true;// ibs    
bool rsi = true;// rsi    
bool cci = true;// cci    
bool _1 = false;//   ,    2-          
int Shift = 0;//  
bool positive = true;// 
int SmoothMode_VKWB = 0;//  VKWB
//------------------------------------------------------------          
//---- buffers
double E0[], E1[], E2[], E3[], E4[], E5[], E6[], E7[], huu[],hud[], hdd[],hdu[];
int kibs=-1,kcci=-1,krsi=-1,posit=-1,xma1=1;
//------------------------------------------------------------
int init(){
//---- indicators
   IndicatorBuffers(12); 
   SetIndexBuffer(0,hud); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,huu); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,hdu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,hdd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,E0);
   SetIndexBuffer(5,E7); 
   SetIndexBuffer(6,E1);   
   SetIndexBuffer(7,E2);
   SetIndexBuffer(8,E3);
   SetIndexBuffer(9,E4);  
   SetIndexBuffer(10,E5);
   SetIndexBuffer(11,E6);
        
   if(cci)kcci=1; if(rsi)krsi=1; if(ibs)kibs=1; 
   if(_1)xma1=0; if(positive)posit=1;   
//----       
return(0);}
//------------------------------------------------------------
int deinit(){return(0);}
//------------------------------------------------------------
int start()
  {
   int  cb=IndicatorCounted();
//----
   int i,limit,limit1,limit2,n_max,n_min;
   if(cb==0){limit=Bars-1; limit1=Bars-RangePeriod_VKWB; limit2=limit1-SmoothPeriod_VKWB;}
   if(cb>0) {limit=Bars-cb; limit1=Bars-cb; limit2=limit1;}  
   limit--;limit1--;limit2--;
   
   Delitel(E2,limit);
   for(i=limit;i>=0;i--)
      {E1[i]=posit*iMA_IBS_RSI_CCI( E2,
                                    per_IBS , per_RSI      , per_CCI      ,
                                      , app_price_RSI, app_price_CCI,
                                    koef_ibs, koef_rsi     , koef_cci     ,
                                    kibs    , krsi         , kcci         ,
                                    i+Shift);                   
      }
   for(i = limit;i>=0;i--)
      {E0[i]=E0[i+1];
       double raz10=E1[i]-E0[i];      
       if(MathAbs(raz10)>porog) 
      {if(raz10>0) E0[i]=E1[i]-porog*xma1;
       if(raz10<0) E0[i]=E1[i]+porog*xma1;
      }         
      } 
   for(i=limit1; i>=0;i--)
      {n_max=ArrayMaximum(E0,RangePeriod_VKWB,i);
       n_min=ArrayMinimum(E0,RangePeriod_VKWB,i);
       E3[i]=E0[n_max];
       E4[i]=E0[n_min];
      }
   for(i=limit2; i>=0;i--)
      {E5[i]=iMAOnArray(E3,0,SmoothPeriod_VKWB,0,SmoothMode_VKWB,i);
       E6[i]=iMAOnArray(E4,0,SmoothPeriod_VKWB,0,SmoothMode_VKWB,i);
      }   
   for(i=limit; i>=0;i--)
      {E7[i]=(E5[i]+E6[i])/2;
      }                             

   for(i=limit; i>=0;i--)
   {
      huu[i] = EMPTY_VALUE;
      hud[i] = EMPTY_VALUE;
      hdu[i] = EMPTY_VALUE;
      hdd[i] = EMPTY_VALUE;
      if (E0[i]>E7[i] &&  E7[i]>0) { huu[i] = 1; continue; }
      if (E0[i]>E7[i] ||  E0[i]>0) { hud[i] = 1; continue; }
      if (E0[i]<E7[i] &&  E7[i]<0) { hdd[i] = 1; continue; }
      if (E0[i]<E7[i] ||  E0[i]<0) { hdu[i] = 1; continue; }
   }
//----
return(0);}
//------------------------------------------------------------
void Delitel(double& ExtMapBuffer[],int limit)
{
 double delitel;
 for(int i=limit;i>=0;i--)
    {delitel=High[i]-Low[i];
     if (delitel>0)  ExtMapBuffer[i]=(Close[i]-Low[i])/delitel;
     else ExtMapBuffer[i]=0.0;
    }
return;}
//------------------------------------------------------------ 
double iMA_IBS_RSI_CCI(double& ExtMapBuffer[],
                      int tper_IBS,int tper_RSI,int tper_CCI,
                      int t,int tapp_price_RSI,int tapp_price_CCI,
                      double tkoef_ibs,double tkoef_rsi,double tkoef_cci,
                      int tkibs,int tkrsi,int tkcci,
                      int i)
{
 double sum=0.0;
 sum+=tkibs*(iMAOnArray(ExtMapBuffer,0,tper_IBS,0,MODE_SMA,i)-0.5)*100.0*tkoef_ibs;
 sum+=tkcci*iCCI(NULL,0,tper_CCI,tapp_price_CCI,i)*tkoef_cci; 
 sum+=tkrsi*(iRSI(NULL,0,tper_RSI,tapp_price_RSI,i)-50.0)*tkoef_rsi;
 sum*=1.0/3.0; 
return(sum);}
//------------------------------------------------------------